// ==========================================================================
// $Source: 
//
// ==========================================================================
#include <stdio.h>
#include "pth_error.h"
#include <iostream>
#include <string>
#include <stdlib.h>
#include <sstream>

// Scan arg
namespace PTH {

// -- write the into the stream o
 std::ostream& RuntimeError::print( std::ostream& o ) const
{ 
  o <<  what(); 
  return o;
}

const char* RuntimeError::what()const throw() 
{
  std::ostringstream tmp ;
  tmp << "[[ " <<
     _msg << "]]code=" <<
    _code <<"==>"<<
    _whatmsg();
  return tmp.str().c_str();
}

int RuntimeError::code() const throw ()
{ return _code; }

void throwit(  const RuntimeError& err ) throw(const RuntimeError&)
{
  std::cerr << "[PTH::throwit] called:" << err.what() << std::endl;
  throw err;
}


} // - namespace
