/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __RSH_H
#define __RSH_H


#include <vector>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string>
#include "connector.h"

class rsh:public connector
{

  void run()
	{
		const int rport=514;
		int tcpopt_nodelay_on=1;

		//dbg.log("rsh","rsh begin\n");
		for(int i=0; i<remote_hosts.size(); i++)
			{
				char* r_host = strcpy((char*)malloc(remote_hosts[i]->name.size()+1),remote_hosts[i]->name.c_str());
				//dbg.log("rsh","rsh strcpy done ok\n");
#ifdef PTH_USE_PTHREAD_IRIX
				if ((remote_hosts[i]->fd = rcmd((char**) &r_host,rport, (char*)local_user.c_str(),(char*)remote_hosts[i]->login.c_str(),(char*)remote_hosts[i]->cmd.c_str(), NULL)) <0)
#else
				if ((remote_hosts[i]->fd = rcmd((char**) &r_host,rport, local_user.c_str(),remote_hosts[i]->login.c_str(),remote_hosts[i]->cmd.c_str(), NULL)) <0)
#endif
		{
			//dbg.log("rsh","rsh ERROR on rcmd\n");
			reject->push_back(remote_hosts[i]);
		}
				//dbg.log("rsh","rsh RCMD done ok\n");
				if(setsockopt(remote_hosts[i]->fd,IPPROTO_TCP,TCP_NODELAY,&tcpopt_nodelay_on,sizeof(tcpopt_nodelay_on))==-1)
		{
			perror("WARNING:");
		}
			}
	}

};

#endif //__RSH_H
