/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __RSH_FORK_H
#define __RSH_FORK_H


#include <vector>
#include <string>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "connector.h"
#include "taktukexec.h"
#include <sys/types.h>
#include <signal.h>

class rsh_fork:public connector
{
public:
    rsh_fork()
    {
			size=0;
      pid=0;
    }

  void run()
	{
		//int tcpopt_nodelay_on=1;
		int nb_hosts=remote_hosts.size();
		size=nb_hosts;
		int fd[nb_hosts];
		
		
		
		std::vector<std::string> cmd_rsh;
		for(int i=0; i<nb_hosts; i++)
			{ 
				if(remote_hosts[i]->gateaccess.empty())
					cmd_rsh.push_back("rsh -l " +  remote_hosts[i]->login + " " + remote_hosts[i]->name + " " + remote_hosts[i]->cmd ); 
				else
					cmd_rsh.push_back(remote_hosts[i]->gateaccess + " rsh -l " +  remote_hosts[i]->login + " " + remote_hosts[i]->name + " " + remote_hosts[i]->cmd );

			}
		
		for(int i=0; i<nb_hosts; i++){
			fd[i]=taktukexec((char*)cmd_rsh[i].c_str(),&pid);
		}
		
		for(int i=0; i<nb_hosts; i++)
			{
				if (fd[i] == -1)
		{
			reject->push_back(remote_hosts[i]);
		}
				remote_hosts[i]->fd=fd[i];
			}
		
	}
 void cancel()
  {
    if(pid!=0&&size==1)
      kill(pid,SIGKILL);
  }
  private:
    int pid;
		int size;

};

#endif //__RSH_FORK_H
