/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __SSF_H
#define __SSF_H


#include <vector>
#include <string>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "connector.h"
#include "taktukexec.h"


class ssf:public connector
{
  void run()
	{
		int nb_hosts=remote_hosts.size();

		std::vector<std::string> cmd_ssh;

		int fd[nb_hosts];


		char* redirector = getenv("SPREAD_REDIR");
		std::string redir_str;
		if(redirector==NULL)
			{
				for(int i=0; i<nb_hosts; i++)
		{
			reject->push_back(remote_hosts[i]);
			remote_hosts[i]->fd=-1;
		}
				return;
			}
		else
			redir_str=redirector;


		for(int i=0; i<nb_hosts; i++)
			{
				cmd_ssh.push_back("ssf -q -o BatchMode=yes  -o StrictHostKeyChecking=no " +  remote_hosts[i]->login + "@" + remote_hosts[i]->name + " " +redir_str + " " + remote_hosts[i]->cmd );


			}

		for(int i=0; i<nb_hosts; i++){
			fd[i]=taktukexec((char*)cmd_ssh[i].c_str());
		}

		for(int i=0; i<nb_hosts; i++)
			{
		if (fd[i] == -1)
		{
			reject->push_back(remote_hosts[i]);
		}
				remote_hosts[i]->fd=fd[i];
			}
	}
};

#endif //__SSF_FORK_H
