// ==========================================================================
// $Source: /home/cvs/Taktuk2/NetworkCore/src/acom_comerror.cpp,v $
// Copyright(c)'2001 by Apache Team
// acom_error.cpp : Error handling functions
// Author: Jacques Briat
// $Id: acom_comerror.cpp,v 1.1.1.1 2004/06/29 13:32:12 martinc Exp $
// ==========================================================================
#include "acom_comerror.h"

namespace ACOM_NET_NAMESPACE {

static const char*  ErrorMsg []= {
  "OK", 
  "FAIL ",
  "TRUNCATED ",
  "NOT_FILLED ",
  "FATAL ",
  "NOROUTE ",
  "NULL_SERVICE ",
  "BAD OR NULL REQUEST  ",
  "PANIC ",
  "NOT_IMPLEMENTED ",
  "BAD_ADDRESS ",
  "NO_CONNECTION ",
  "BAD_PROTOCOL "
};



const char * ComFailure:: _whatmsg() const throw (){
		 if ( (((Code)_code)>=0) && (((Code)_code) <= BAD_PROTOCOL) ) 
    return ErrorMsg[_code];
  else  
    return "UNDEFINED COMFAILURE ERROR CODE " ;  };
} // -namespace
