// ==========================================================================
// $Source: /home/cvs/Taktuk2/NetworkCore/src/acom_netclient.cpp,v $
// Copyright(c)'2001 by Apache Team
// acom_network.cpp : 
// Authors: Jacques Briat, Thierry Gautier
// ==========================================================================
#include <inuk/acom_network.h>
#include <inuk/acom_callback.h>

namespace ACOM_NET_NAMESPACE {


// --------------------------------------------------------------------
NetworkClient::NetworkClient()
{
}
  

// --------------------------------------------------------------------
NetworkClient::~NetworkClient()
{
}
  

// --------------------------------------------------------------------
void NetworkClient::Request::notify()
{  
  --_used_ct; 
  if(_used_ct==0)
  { 
    if (_f_cbk!=0) _f_cbk->done( this );
    finish(); 
    _net->deallocate_request( this );
  }
}


// --------------------------------------------------------------------
bool NetworkClient::cancel_request( Request* req ) 
  throw (InvalidArgument) 
{ 
  return false; 
}


// --------------------------------------------------------------------
void NetworkClient::post( Request* req, OutChannel* ch ) 
    throw (ComFailure)
{ 
  throwit( ComFailure("[post]",ComFailure::NOT_IMPLEMENTED)); 
}
 
} // - namespace ACOM_...
