// ==========================================================================
// $Source: /home/cvs/Taktuk2/Pthread/src/pth_system.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Authors: J. Briat & T. Gautier 
// $Id: pth_system.cpp,v 1.1.1.1 2004/06/29 13:32:12 martinc Exp $

// ==========================================================================
// the namespace identifier

#include <pth_ns.h>
#include <pth_pthreadsync.h>
#include <pth_timer.h>
#include <pth_system.h>
#include <pth_log.h>


namespace PTH {

static int count_initialize =0;
void Pth::initialize(int* ac, char*** av ) throw (PosixError)
{ 
//  std::string TraceFileName;


  ++count_initialize;
  //  std::cout<<count_initialize<<"\nl";
  static bool once=true; if (once) once=false; else return;


  try
  {
  } catch(...){
    std::cout << "exception variable" << std::endl << std::flush; 
    return;
  } 
    
  try
  {
    Mutex::init_static();
  } catch(...){
    std::cout << "exception Mutex::init_static" << std::endl << std::flush; 
    return;
  } 
    
    try
  {
    Condition::init_static();
  } catch(...){
    std::cout << "exception Cond::init_static" << std::endl << std::flush; 
    return;

  } 


    
  try
  {
    Thread::init_static();
  } catch(...){
    std::cout << "exception Th::init_static" << std::endl << std::flush; 
    return;

  } 

  /* Calibrate clock */
  HighResTimer::calibrate();

}


void Pth::commit()throw (PosixError)
{
static bool once=true;
if (once) 
  {once=false;}
else 
  {return;}

}
 
void Pth::terminate()throw (PosixError)
{
if (--count_initialize > 0) return;
static bool once=true;
if (once) once=false; 
else return;

}



} // -namespace
