/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __FORK_H
#define __FORK_H


#include <vector>
#include <string>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "connector.h"
#include "taktukexec.h"


class confork:public connector
{
  void run()
	{
		//int tcpopt_nodelay_on=1;
		int nb_hosts=remote_hosts.size();

		int fd[nb_hosts];
		
		
		
		std::vector<std::string> cmd_rsh;
		for(int i=0; i<nb_hosts; i++)
			{      
				cmd_rsh.push_back( remote_hosts[i]->cmd ); 

			}
		
		for(int i=0; i<nb_hosts; i++){
			fd[i]=taktukexec((char*)cmd_rsh[i].c_str());
		}
		
		for(int i=0; i<nb_hosts; i++)
			{
				if (fd[i] == -1)
		{
			reject->push_back(remote_hosts[i]);
		}
				remote_hosts[i]->fd=fd[i];
			}
		
	}
};

#endif //__FORK_H
