/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __RSH_ASYNC_H
#define __RSH_ASYNC_H


#include <vector>
#include <string>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <stdio.h>
#include <iostream>
#include "connector.h"
#include "rcmd_async.h"

class rsh_async:public connector
{
  void run()
	{
		const int rport=514;
		int tcpopt_nodelay_on=1;
		int nb_hosts=remote_hosts.size();
		const char* r_hosts[nb_hosts];
		char* cmd_str[nb_hosts];
		int fd[nb_hosts];


		

		for(int i=0; i<nb_hosts; i++)
			{      
				r_hosts[i]=remote_hosts[i]->name.c_str();
				cmd_str[i]=(char*)remote_hosts[i]->cmd.c_str();
			}
		rcmd_async((char**)r_hosts,nb_hosts,fd,rport, (char*)local_user.c_str(),(char*)remote_hosts[0]->login.c_str(),cmd_str);
		for(int i=0; i<nb_hosts; i++)
			{
				if(fd[i]>0)
		{
			if(setsockopt(fd[i],IPPROTO_TCP,TCP_NODELAY,&tcpopt_nodelay_on,sizeof(tcpopt_nodelay_on))==-1)
				{
					perror("WARNING:");
				}
		}
				else
		{
			reject->push_back(remote_hosts[i]);
		}
				remote_hosts[i]->fd=fd[i];
			}
	}
};

#endif //__RSH_ASYNC_H
