#include <inuk/taktuk/mput_sender.h>
#include <inuk/taktuk/mput_wrappers.h>
#include <inuk/taktuk/mput_buffers.h>

void * sender(void * socket)
{
   int current_buffer = 0;
   int finished = 0;
   int n;
   while(!finished)
   {
      Pthread_mutex_lock(&(buffers[current_buffer].prod_mutex));
      while(buffers[current_buffer].prod == 1)
      {
         if( check_point->finished && ( check_point->buff_number == current_buffer ) )
	 {
	    return NULL;
	 }
         Pthread_cond_wait(&(buffers[current_buffer].prod_cond),&(buffers[current_buffer].prod_mutex));
      }
      Pthread_mutex_unlock(&(buffers[current_buffer].prod_mutex));
      
      n=0;
      while( (n += Write(*((int *)socket),&(buffers[current_buffer].buff[n]),MAXBUFF-n)) < MAXBUFF)
      {
         ;
      }
      Pthread_mutex_lock(&(buffers[current_buffer].buffer_full_mutex));
      
      buffers[current_buffer].buffer_full--;
      if(buffers[current_buffer].buffer_full == 0)
         Pthread_cond_signal(&(buffers[current_buffer].buffer_full_cond));
      Pthread_mutex_unlock(&(buffers[current_buffer].buffer_full_mutex));

      current_buffer++;
      if(current_buffer == NBBUFF)
         current_buffer = 0;
   }
}
